SoClipPlane(3)

NAME
SoClipPlane - The SoClipPlane class is a node type for specifying clipping planes.

SYNOPSIS

#include <Inventor/nodes/SoClipPlane.h>

Inherits SoNode.

Inherited by SoClipPlaneManip.

  Public Member Functions
virtual SoType getTypeId (void) const
SoClipPlane (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)
virtual void pick (SoPickAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFPlane plane
SoSFBool on

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoClipPlane ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoClipPlane class is a node type for specifying clipping planes. A scene graph without any SoClipPlane nodes uses six clipping planes to define the viewing frustum: top, bottom, left, right, near and far. If you want extra clipping planes for 'slicing' the visible geometry, you can do that by using nodes of this type. Geometry on the back side of the clipping plane is clipped away.

Note that OpenGL implementations have a fixed maximum number of clipping planes available. To find out what this number is, you can use the following code:

#include <Inventor/elements/SoGLClipPlaneElement.h>
// ...[snip]...
int maxplanes = SoGLClipPlaneElement::getMaxGLPlanes();

Below is a simple, basic scene graph usage example of SoClipPlane. It connects an SoClipPlane to an SoCenterballDragger, for end-user control over the orientation and position of the clipping plane:

#Inventor V2.1 ascii
Separator {
   Separator {
      Translation { translation -6 0 0 }
      DEF cbdragger CenterballDragger { }
   }
   TransformSeparator {
      Transform {
         rotation 0 0 1 0 = USE cbdragger . rotation
         translation 0 0 0 = USE cbdragger . center
      }
      ClipPlane { }
   }
   Sphere { }
}

Note that SoClipPlane is a state-changing appearance node, and as such, it will only assert its effects under the current SoSeparator node (as the SoSeparator pops the state stack when traversal returns above it), as can be witnessed by loading this simple example file into a Coin viewer:

#Inventor V2.1 ascii
Separator {
   ClipPlane { }
   Cube { }
}
Separator {
   Translation { translation -3 0 0 }
   Cube { }
}

FILE FORMAT/DEFAULTS:

ClipPlane {
    plane 1 0 0  0
    on TRUE
}

Constructor & Destructor Documentation

  SoClipPlane::SoClipPlane (void)
Constructor.

  SoClipPlane::~SoClipPlane () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoClipPlane::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoClipPlane::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

Reimplemented in SoClipPlaneManip.

  const SoFieldData ** SoClipPlane::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoClipPlane::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

Reimplemented in SoClipPlaneManip.

  void SoClipPlane::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

Reimplemented in SoClipPlaneManip.

  void SoClipPlane::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

Reimplemented in SoClipPlaneManip.

  void SoClipPlane::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

Reimplemented in SoClipPlaneManip.

  void SoClipPlane::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

Reimplemented in SoClipPlaneManip.

Member Data Documentation

  SoSFPlane SoClipPlane::plane
Definition of clipping plane. Geometry on the back side of the clipping plane is clipped away.

The default clipping plane has its normal pointing in the <1,0,0> direction, and intersects origo. (I.e., everything along the negative X-axis is clipped.)

  SoSFBool SoClipPlane::on
Whether clipping plane should be on or off. Defaults to TRUE.

Author

Generated automatically by Doxygen for Coin from the source code.